# ATAT Builder for Debian
This repository enables the reproducible compilation of ATAT (https://www.brown.edu/Departments/Engineering/Labs/avdw/atat/).

It produces binaries compatible with any version of Debian.

## Getting Started
To compile ATAT binaries compatible with `bullseye` (replace with any valid `Debian` release), run the following:
```bash
./run.py compile bullseye
```

The binaries will be made available in `bin/`.

## Building for Non-Debian
If you want to compile ATAT binaries for systems other than a particular release of Debian, you can easily modify this repository to do so.

First, you must find a suitable image:
```python
IMAGE_NAME = "docker.io/debian"
```

Second, for the `<release>` release of your system, replace the following such that `{}` will be replaced by `<release>`:
```python
IMAGE_TAG_FMT = "{}-slim"
```

Thirdly, add a `scripts/compile-<system>.sh` file, and replace the following:
```python
PATH_COMPILE_ATAT = SCRIPT_PATH / 'scripts' / 'compile-<system>.sh'
```

Finally, you can now compile for the new system at `<release>` using:
```bash
./run.py compile <release>
```
